
procedure	noshiftcomb( imlist, output, n_image, st_log, offset )

file	imlist		{prompt = "Input image list with @ mark"}
file    output          {prompt = "Output image name"}
int     n_image         {prompt = "Input number of images in each sub-group"}
file    st_log          {prompt = "Log file of flux, sky, and FWHM of the selected star"}
file    offset          {prompt = "Output offset file"}

struct  *list2_2  {mode = 'h'}
struct  *list3_2  {mode = 'h'}
struct  *list5    {mode = 'h'}
struct  *list6    {mode = 'h'}
struct  *list6_2  {mode = 'h'}
#
#
begin
	string	tmpfile1, tmpfile2, tmpfile2_2, tmpfile3_2, tmpfile4
	string	tmpfile5, tmpfile6, tmpfile6_2, tmpfile7

	string 	junk1, junk2, junk3, junk4, junk5, junk6, junk7

	string  filelist1

        string  tmpimage2, tmpimage6, tmpimage7

	string  output1, offset1

        string  wcs

	string  st_log1

        int     i, nimage

        real    flux1, sky1, el1, pa1, fwhm1
        real    flux2, sky2, el2, pa2, fwhm2
        real    flux3, sky3, el3, pa3, fwhm3
        real    flux4, sky4, el4, pa4, fwhm4
        real    flux5, sky5, el5, pa5, fwhm5
        real    flux6, sky6, el6, pa6, fwhm6

        real    x_str, y_str
	real    x_org, y_org
	real    x_shift, y_shift
	real    x, y
        
        string  key
	struct  command
	int     npoint

	filelist1 = imlist
	tmpfile3_2 = mktemp( "tmp_file." )
# ---- Image Name or Image List with @ mark ?
	sections( filelist1, option='fullname', > tmpfile3_2 )
	list3_2 = tmpfile3_2

	list5 = ""
	list6 = ""
	list6_2 = ""

	output1 = output
	offset1 = offset
        nimage = n_image
	st_log1 = st_log

	junk1=""
	junk2=""
	junk3=""
	junk4=""
	junk5=""
	junk6=""
	junk7=""

#        reset stdimage = imt1024

        tmpfile1 = mktemp( "tmp_file." )
        tmpfile2 = mktemp( "tmp_file." )
        tmpfile2_2 = mktemp( "tmp_file." )

        i=0
        j=0
	while( fscan( list3_2, junk1 ) == 1 ) 
	{
            print( junk1, >> tmpfile1 )
            i = i+1
            if( i == nimage ){
                  tmpimage2 = mktemp( "tmp_im.")
                  print( tmpimage2, >> tmpfile2 )
                  imcomb("@"//tmpfile1 ,tmpimage2,combine='average',reject='sigclip',outtype='real',lthresh=INDEF,hthresh=INDEF,lsigma=2, hsigma=2)
                  delete( tmpfile1,ver-,>&"dev$null" )
                  display(tmpimage2,1,fi+,zs+,zr+)
                  i = 0
                  j = j + 1
                  print( "Frame", j, " ended" )
                  if(j<10) print( output1,".00",j, >> tmpfile2_2 )
                  else if(j<100) print( output1,".0",j, >> tmpfile2_2 )
                  else print( output1,".",j, >> tmpfile2_2 )
                  }
         }
         imrename( "@"//tmpfile2,"@"//tmpfile2_2 )

        list2_2 = tmpfile2_2
        tmpfile4  = mktemp( "tmp_file." )
        tmpfile5  = mktemp( "tmp_file." )
        tmpfile6  = mktemp( "tmp_file." )
        tmpfile6_2= mktemp( "tmp_file." )

        x_org = 0
        y_org = 0

        print( "Measure a shift value using IMEXAM." )

        print( "Move cursor to a reference star ( which is not saturated ) " )
        print( " and push   "  )
        print( "           a to mesure " ) 
        print( "           q to finish a mesurement of the current frame and move to next one " )
        print( " If you mistake, push a again and the data is revised." )
        
        while( fscan( list2_2, junk1 ) == 1 ) 
        {
            display(junk1,1,zs+,zr+,z1=INDEF,z2=INDEF)
		npoint = 0

		while( fscan( imcur, x, y, wcs, command) != EOF)
		{
                key = substr(command,1,1)
		if( key == 'a')
         	     {
	             delete( tmpfile4,ver-,>&"dev$null" )
	             delete( tmpfile5,ver-,>&"dev$null" )

                     print(":",x,y," ,", >> tmpfile4)
                     print(":center yes", >> tmpfile4)
                     print(":fittype gaussian", >> tmpfile4)
                     print(":iterations 1", >> tmpfile4)
		     print(":radius 5", >> tmpfile4)
		     print(":buffer 5", >> tmpfile4)
		     print(":width  5", >> tmpfile4)
		     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 10", >> tmpfile4)
                     print(":buffer 10", >> tmpfile4)
                     print(":width 10", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 15", >> tmpfile4)
                     print(":buffer 15", >> tmpfile4)
                     print(":width 15", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 20", >> tmpfile4)
                     print(":buffer 20", >> tmpfile4)
                     print(":width 20", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 3", >> tmpfile4)
                     print(":buffer 3", >> tmpfile4)
                     print(":width 3", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 4", >> tmpfile4)
                     print(":buffer 4", >> tmpfile4)
                     print(":width 4", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 5", >> tmpfile4)
                     print(":buffer 5", >> tmpfile4)
                     print(":width 5", >> tmpfile4)
                     wcsreset( junk1, "physical" )
		     imexam(junk1,logfile=tmpfile5,keeplog+,graphcur-, imagecur=tmpfile4,wcs="physical", graphic="stdgraph",use_dis+)
                     list5 = tmpfile5
                     if( fscan( list5, junk2 ) == 1){
                     if( fscan( list5, junk2 ) == 1){
		     if( fscan( list5, junk2 ) == 1){
                        if( fscan( list5, x_str, y_str, junk4, flux1, sky1, junk5, junk6, el1, pa1, junk7, fwhm1) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux2, sky2, junk5, junk6, el2, pa2, junk7, fwhm2) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux3, sky3, junk5, junk6, el3, pa3, junk7, fwhm3) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux4, sky4, junk5, junk6, el4, pa4, junk7, fwhm4) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux5, sky5, junk5, junk6, el5, pa5, junk7, fwhm5) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux6, sky6, junk5, junk6, el6, pa6, junk7, fwhm6) == 11){
                           x=x_str
                           y=y_str
                           npoint = 1
                           }}}}}}
			}}}
		     }
                else if( key == 'q')
		   {
		   if( npoint == 0)  
                       {
                        print( "No measurement has been made for this frame !" )
                        beep
                        }
                   else
                     break
		   } 
                else 
		   beep
                } 
            x_org = x_str
            y_org = y_str
            print( junk1, " ", x_str, " ", y_str, >> tmpfile6 )
            print( junk1, "   ", x_str, y_str, flux1, sky1, el1, pa1, fwhm1, flux2, sky2, el2, pa2, fwhm2, flux3, sky3, el3, pa3, fwhm3, >> st_log1 )
            x_org = int( x_org + 0.5)
            y_org = int( y_org + 0.5)
            print( x_org, y_org, >> tmpfile6_2 )
            print( -x_org, -y_org, >> offset1 )
	    }
         

###############################################
#---- Step 6 - 7
#---- Image Shift
#---- and Combine
###############################################

         tmpfile7 = mktemp( "tmp_file." )

         i=0
         j=0
         list6 = tmpfile6
         list6_2 = tmpfile6_2
         while( fscan( list6, junk1, x_str, y_str) == 3)
	 {
             if( fscan( list6_2, x_org, y_org ) == 2){}
             tmpimage6 = mktemp( "tmp_im.")
             x_shift = x_org - x_str
             y_shift = y_org - y_str
             imshift(junk1, tmpimage6, x_shift, y_shift, interp='linear', boundar='nearest')
             print( tmpimage6, >> tmpfile7 )
             print( junk1, " shifted to ", x_shift, y_shift)
	 }
	 imcomb("@"//tmpfile7 ,output1,combine='median',reject='sigclip',outtype='real',lthresh=INDEF,hthresh=INDEF,lsigma=2, hsigma=2, offset=offset1)
         imdelete ( "@"//tmpfile7 )
         delete( tmpfile7,ver-,>&"dev$null" )
         display(output1,1,fi+,zs+,zr+)

finish:
	delete( tmpfile1,ver-,>&"dev$null" )
	delete( tmpfile2,ver-,>&"dev$null" )
	delete( tmpfile2_2,ver-,>&"dev$null" )
	delete( tmpfile3_2,ver-,>&"dev$null" )
	delete( tmpfile4,ver-,>&"dev$null" )
	delete( tmpfile5,ver-,>&"dev$null" )
	delete( tmpfile6,ver-,>&"dev$null" )
	delete( tmpfile6_2,ver-,>&"dev$null" )
	print( 'This procedure ended.' )
	bye
end
