#! /bin/csh -f

set DATADIR=$1
set NS=$2
set NF=$3
set NP=$4

mkdir data
gawk -v ns=$NS -v nf=$NF -v np=$NP -v datadir=$DATADIR 'BEGIN{nn=nf*np;for(i=ns;i<ns+nn;i++) printf("%s/OHSA%08d.fits\n",datadir,i)}' > rdata.tbl
gawk -v ns=$NS -v nf=$NF -v np=$NP 'BEGIN{nn=nf*np;for(i=ns;i<ns+nn;i++) printf("./data/cisco%04d.fits\n",i)}' > ldata.tbl
sed 's/.imh/.imh[257:768,257:768]/g' ldata.tbl > pldata.tbl
gawk -v nf=$NF '{if(i<1) print($0); i++; if(i==nf) i=0;}' ldata.tbl > ldata.1.tbl
gawk -v nf=$NF '{if(i>=1) print($0); i++; if(i==nf) i=0;}' ldata.tbl > ldata.2.tbl
sed 's/.imh/.imh[257:768,257:768]/g' ldata.1.tbl > pldata.1.tbl

echo "tmp3[1:512,1:512]" > offsetfix1.tbl
echo "tmp3[1:512,513:1024]" >> offsetfix1.tbl
echo "tmp3[513:1024,1:512]" >> offsetfix1.tbl
echo "tmp3[513:1024,513:1024]" >> offsetfix1.tbl
echo "tmp01.imh" > offsetfix2.tbl
echo "tmp02.imh" >> offsetfix2.tbl
echo "tmp03.imh" >> offsetfix2.tbl
echo "tmp04.imh" >> offsetfix2.tbl
echo "tmp3[*,1:512]" > offsetfix3.tbl
echo "tmp3[*,513:1024]" >> offsetfix3.tbl
echo "tmp01.imh" > offsetfix4.tbl
echo "tmp02.imh" >> offsetfix4.tbl

echo "imdel @ldata.tbl" | cl
echo "imarith @rdata.tbl / flatk.fits @ldata.tbl" | cl

echo "### Preparation for MKSUBGR command ###"
echo "del level.tbl" > cl.com
echo "imstatistics @pldata.1.tbl field=mean fo- > level.tbl" >> cl.com
cat cl.com | cl
awk '{s+=$1;i++;}END{print(s/i)}' level.tbl > tmp.txt
echo "imdel sky1,sky2" > cl.com
echo "imdel sky*.imh" >> cl.com
echo "del bkg1.tbl,bkg2.tbl" >> cl.com
cat cl.com | cl

echo "### MKSUBGR command ###"
gawk -v nf=1 '{print("mksubgr @ldata.1.tbl sky1 1 "nf" "$1" 257 768 257 768 bkg1.tbl")}' tmp.txt | cl
gawk -v nf=$NF '{print("mksubgr @ldata.2.tbl sky2 1 "nf-1" "$1" 257 768 257 768 bkg2.tbl")}' tmp.txt | cl
echo "offsetrej sky1" | cl
echo "offsetrej sky2" | cl

echo "### Remove offset 1 (Non-interactive) ###"
echo "imdel tmp1,tmp2,tmp3" > cl.com
echo "imarith sky1 - sky2 tmp1" >> cl.com
echo "disp tmp1 1 fi+" >> cl.com
echo "median tmp1[*,51:974] tmp1 1 25" >> cl.com

echo "blkav tmp1 tmp1 1 2000" >> cl.com
echo "magnify tmp1 tmp1 1. 0.0009765625 y2=1024 dy=1 interpo=nearest boundar=nearest fluxcon-" >> cl.com
echo "imcopy sky2 tmp2" >> cl.com
echo "imarith tmp2 + tmp1 tmp3" >> cl.com
echo "displ tmp3 1 fi+" >> cl.com
echo "imdel tmp3" >> cl.com
echo "imcopy sky1 tmp3" >> cl.com
#echo "displ tmp3 1 fi+" >> cl.com
echo "displ sky2.001 1 fi+" >> cl.com
echo "logout" >> cl.com
cat cl.com | cl
