
procedure	rotshiftcomb( imlist, output, n_image, max_fwhm, st_log, offset )

file	imlist		{prompt = "Input image list with @ mark"}
file    output          {prompt = "Output image name"}
int     n_image         {prompt = "Input number of images in each sub-group"}
real    max_fwhm        {prompt = "Maximum threshold of FWHM selection"}
file    st_log          {prompt = "Log file of flux, sky, and FWHM of the selected star"}
file    offset          {prompt = "Output offset file"}

struct  *list3_2  {mode = 'h'}
struct  *list5    {mode = 'h'}
struct  *list6    {mode = 'h'}
struct  *list6_2  {mode = 'h'}
#
#
begin
	string	tmpfile3_2, tmpfile4
	string	tmpfile5, tmpfile6, tmpfile6_2, tmpfile7, tmpfile8, tmpfile8_2

	string 	junk1, junk2, junk3, junk4, junk5, junk6, junk7

	string  filelist1

        string  tmpimage6, tmpimage7

	string  output1, offset1

        string  wcs

	string  st_log1

        int     i, nimage, nselect, ntotal

        real    flux1, sky1, el1, pa1, fwhm1
        real    flux2, sky2, el2, pa2, fwhm2
        real    flux3, sky3, el3, pa3, fwhm3
        real    flux4, sky4, el4, pa4, fwhm4
        real    flux5, sky5, el5, pa5, fwhm5
        real    flux6, sky6, el6, pa6, fwhm6
        real    flux1r, sky1r, el1r, pa1r, fwhm1r
        real    flux2r, sky2r, el2r, pa2r, fwhm2r
        real    flux3r, sky3r, el3r, pa3r, fwhm3r
        real    flux4r, sky4r, el4r, pa4r, fwhm4r
        real    flux5r, sky5r, el5r, pa5r, fwhm5r
        real    flux6r, sky6r, el6r, pa6r, fwhm6r
        real    maxfwhm

        real    x_str, y_str, xr_str, yr_str
	real    x_org, y_org, xr_org, yr_org
	real    x_shift, y_shift, x_rot, y_rot
	real    xin, yin, x, y, xr, yr, ang, sina
        
        string  key
	struct  command
	int     npoint, nrpoint

	filelist1 = imlist
	tmpfile3_2 = mktemp( "tmp_file." )
# ---- Image Name or Image List with @ mark ?
	sections( filelist1, option='fullname', > tmpfile3_2 )
	list3_2 = tmpfile3_2

	list5 = ""
	list6 = ""
	list6_2 = ""

	output1 = output
	offset1 = offset
        nimage = n_image
	st_log1 = st_log
        maxfwhm = max_fwhm

	junk1=""
	junk2=""
	junk3=""
	junk4=""
	junk5=""
	junk6=""
	junk7=""

#        reset stdimage = imt1024

        tmpfile4  = mktemp( "tmp_file." )
        tmpfile5  = mktemp( "tmp_file." )
        tmpfile6  = mktemp( "tmp_file." )
        tmpfile6_2= mktemp( "tmp_file." )

	x_org = 0
	y_org = 0
	xr_org = 0
	yr_org = 0
        x_rot = 0
        y_rot = 0

        print( "Measure a shift value using IMEXAM." )

        print( "Move cursor to a reference star ( which is not saturated ) " )
        print( " and push   "  )
        print( "           a to mesure " ) 
        print( "           r to mesure PA reference (in first frame only)" ) 
        print( "           q to finish a mesurement of the current frame and move to next one " )
        print( " If you mistake, push a again and the data is revised." )
        
        i = 0
        nselect = 0
        nrpoint = 0
        ntotal = 0
	while( fscan( list3_2, junk1 ) == 1 ) {
        if( junk1 != "#" ) {
            display(junk1,1,zs+,zr+,z1=INDEF,z2=INDEF)
	    if(nselect == 0)
	    {
		npoint = 0

		while( fscan( imcur, xin, yin, wcs, command) != EOF)
		{
                key = substr(command,1,1)
		if( key == 'a')
         	     {
	             delete( tmpfile4,ver-,>&"dev$null" )
	             delete( tmpfile5,ver-,>&"dev$null" )
                     x = xin
                     y = yin

                     print(":",x,y," ,", >> tmpfile4)
                     print(":center yes", >> tmpfile4)
                     print(":fittype gaussian", >> tmpfile4)
                     print(":iterations 1", >> tmpfile4)
		     print(":radius 5", >> tmpfile4)
		     print(":buffer 5", >> tmpfile4)
		     print(":width  5", >> tmpfile4)
		     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 10", >> tmpfile4)
                     print(":buffer 10", >> tmpfile4)
                     print(":width 10", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 15", >> tmpfile4)
                     print(":buffer 15", >> tmpfile4)
                     print(":width 15", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 20", >> tmpfile4)
                     print(":buffer 20", >> tmpfile4)
                     print(":width 20", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 3", >> tmpfile4)
                     print(":buffer 3", >> tmpfile4)
                     print(":width 3", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 4", >> tmpfile4)
                     print(":buffer 4", >> tmpfile4)
                     print(":width 4", >> tmpfile4)
                     print(":",x,y," ,", >> tmpfile4)
                     print(":radius 5", >> tmpfile4)
                     print(":buffer 5", >> tmpfile4)
                     print(":width 5", >> tmpfile4)
                     wcsreset( junk1, "physical" )
		     imexam(junk1,logfile=tmpfile5,keeplog+,graphcur-, imagecur=tmpfile4,wcs="physical", graphic="stdgraph",use_dis+)
                     list5 = tmpfile5
                     if( fscan( list5, junk2 ) == 1){
                     if( fscan( list5, junk2 ) == 1){
		     if( fscan( list5, junk2 ) == 1){
                        if( fscan( list5, x_str, y_str, junk4, flux1, sky1, junk5, junk6, el1, pa1, junk7, fwhm1) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux2, sky2, junk5, junk6, el2, pa2, junk7, fwhm2) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux3, sky3, junk5, junk6, el3, pa3, junk7, fwhm3) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux4, sky4, junk5, junk6, el4, pa4, junk7, fwhm4) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux5, sky5, junk5, junk6, el5, pa5, junk7, fwhm5) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux6, sky6, junk5, junk6, el6, pa6, junk7, fwhm6) == 11){
                           x = x_str
                           y = y_str
                           npoint = 1
                           }}}}}}
			}}}
		     }
		if( ( key == 'r' && ntotal==0 && npoint==1 ) || ( key == 'a' && nrpoint==1 ) )
         	     {
	             delete( tmpfile4,ver-,>&"dev$null" )
	             delete( tmpfile5,ver-,>&"dev$null" )
                     if( key == 'r' )
                         {
                         xr = xin
                         yr = yin
                         }
                     if( key == 'a' )
                         {
                         xr = x_str + x_rot
                         yr = y_str + y_rot
                         }

                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":center yes", >> tmpfile4)
                     print(":fittype gaussian", >> tmpfile4)
                     print(":iterations 1", >> tmpfile4)
		     print(":radius 5", >> tmpfile4)
		     print(":buffer 5", >> tmpfile4)
		     print(":width  5", >> tmpfile4)
		     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 10", >> tmpfile4)
                     print(":buffer 10", >> tmpfile4)
                     print(":width 10", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 15", >> tmpfile4)
                     print(":buffer 15", >> tmpfile4)
                     print(":width 15", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 20", >> tmpfile4)
                     print(":buffer 20", >> tmpfile4)
                     print(":width 20", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 3", >> tmpfile4)
                     print(":buffer 3", >> tmpfile4)
                     print(":width 3", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 4", >> tmpfile4)
                     print(":buffer 4", >> tmpfile4)
                     print(":width 4", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 5", >> tmpfile4)
                     print(":buffer 5", >> tmpfile4)
                     print(":width 5", >> tmpfile4)
                     wcsreset( junk1, "physical" )
		     imexam(junk1,logfile=tmpfile5,keeplog+,graphcur-, imagecur=tmpfile4,wcs="physical", graphic="stdgraph",use_dis+)
                     list5 = tmpfile5
                     if( fscan( list5, junk2 ) == 1){
                     if( fscan( list5, junk2 ) == 1){
		     if( fscan( list5, junk2 ) == 1){
                        if( fscan( list5, xr_str, yr_str, junk4, flux1r, sky1r, junk5, junk6, el1r, pa1r, junk7, fwhm1r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux2r, sky2r, junk5, junk6, el2r, pa2r, junk7, fwhm2r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux3r, sky3r, junk5, junk6, el3r, pa3r, junk7, fwhm3r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux4r, sky4r, junk5, junk6, el4r, pa4r, junk7, fwhm4r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux5r, sky5r, junk5, junk6, el5r, pa5r, junk7, fwhm5r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux6r, sky6r, junk5, junk6, el6r, pa6r, junk7, fwhm6r) == 11){
                           x_rot = xr_str - x_str
                           y_rot = yr_str - y_str
                           xr = x_str + x_rot
                           yr = y_str + y_rot
                           nrpoint = 1
                           }}}}}}
			}}}
		     }
                else if( key == 'q')
		   {
		   if( npoint == 0 )
                       {
                        print( "No measurement has been made for this frame !" )
                        beep
                        }
                   else
                     break
		   }
                else if( key != 'a')
		   beep
                } 
	    }
	    else
	    {
                 delete( tmpfile4,ver-,>&"dev$null" )
                 delete( tmpfile5,ver-,>&"dev$null" )

                 print(":",x,y," ,", >> tmpfile4)
                 print(":center yes", >> tmpfile4)
                 print(":fittype gaussian", >> tmpfile4)
                 print(":iterations 1", >> tmpfile4)
                 print(":radius 5", >> tmpfile4)
                 print(":buffer 5", >> tmpfile4)
                 print(":width 5", >> tmpfile4)
                 print(":",x,y," ,", >> tmpfile4)
                 print(":radius 10", >> tmpfile4)
                 print(":buffer 10", >> tmpfile4)
                 print(":width 10", >> tmpfile4)
                 print(":",x,y," ,", >> tmpfile4)
                 print(":radius 15", >> tmpfile4)
                 print(":buffer 15", >> tmpfile4)
                 print(":width 15", >> tmpfile4)
                 print(":",x,y," ,", >> tmpfile4)
                 print(":radius 20", >> tmpfile4)
                 print(":buffer 20", >> tmpfile4)
                 print(":width 20", >> tmpfile4)
                 print(":",x,y," ,", >> tmpfile4)
                 print(":radius 3", >> tmpfile4)
                 print(":buffer 3", >> tmpfile4)
                 print(":width 3", >> tmpfile4)
                 print(":",x,y," ,", >> tmpfile4)
                 print(":radius 4", >> tmpfile4)
                 print(":buffer 4", >> tmpfile4)
                 print(":width 4", >> tmpfile4)
                 print(":",x,y," ,", >> tmpfile4)
                 print(":radius 5", >> tmpfile4)
                 print(":buffer 5", >> tmpfile4)
                 print(":width 5", >> tmpfile4)
                 wcsreset( junk1, "physical" )
                 imexam(junk1,logfile=tmpfile5,keeplog+,graphcur-, imagecur=tmpfile4,wcs="physical", graphic="stdgraph",use_dis+)
                 list5 = tmpfile5
                 if( fscan( list5, junk2 ) == 1){
                 if( fscan( list5, junk2 ) == 1){
                 if( fscan( list5, junk2 ) == 1){
                    if( fscan( list5, x_str, y_str, junk4, flux1, sky1, junk5, junk6, el1, pa1, junk7, fwhm1) == 11){
                    if( fscan( list5, junk2, junk3, junk4, flux2, sky2, junk5, junk6, el2, pa2, junk7, fwhm2) == 11){
                    if( fscan( list5, junk2, junk3, junk4, flux3, sky3, junk5, junk6, el3, pa3, junk7, fwhm3) == 11){
                    if( fscan( list5, junk2, junk3, junk4, flux4, sky4, junk5, junk6, el4, pa4, junk7, fwhm4) == 11){
                    if( fscan( list5, junk2, junk3, junk4, flux5, sky5, junk5, junk6, el5, pa5, junk7, fwhm5) == 11){
                    if( fscan( list5, junk2, junk3, junk4, flux6, sky6, junk5, junk6, el6, pa6, junk7, fwhm6) == 11){
		       x=x_str
                       y=y_str
                       }}}}}}
                    }}}
                 if( nrpoint == 1 ){
                     delete( tmpfile4,ver-,>&"dev$null" )
                     delete( tmpfile5,ver-,>&"dev$null" )

                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":center yes", >> tmpfile4)
                     print(":fittype gaussian", >> tmpfile4)
                     print(":iterations 1", >> tmpfile4)
                     print(":radius 5", >> tmpfile4)
                     print(":buffer 5", >> tmpfile4)
                     print(":width 5", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 10", >> tmpfile4)
                     print(":buffer 10", >> tmpfile4)
                     print(":width 10", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 15", >> tmpfile4)
                     print(":buffer 15", >> tmpfile4)
                     print(":width 15", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 20", >> tmpfile4)
                     print(":buffer 20", >> tmpfile4)
                     print(":width 20", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 3", >> tmpfile4)
                     print(":buffer 3", >> tmpfile4)
                     print(":width 3", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 4", >> tmpfile4)
                     print(":buffer 4", >> tmpfile4)
                     print(":width 4", >> tmpfile4)
                     print(":",xr,yr," ,", >> tmpfile4)
                     print(":radius 5", >> tmpfile4)
                     print(":buffer 5", >> tmpfile4)
                     print(":width 5", >> tmpfile4)
                     wcsreset( junk1, "physical" )
                     imexam(junk1,logfile=tmpfile5,keeplog+,graphcur-, imagecur=tmpfile4,wcs="physical", graphic="stdgraph",use_dis+)
                     list5 = tmpfile5
                     if( fscan( list5, junk2 ) == 1){
                     if( fscan( list5, junk2 ) == 1){
                     if( fscan( list5, junk2 ) == 1){
                        if( fscan( list5, xr_str, yr_str, junk4, flux1r, sky1r, junk5, junk6, el1r, pa1r, junk7, fwhm1r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux2r, sky2r, junk5, junk6, el2r, pa2r, junk7, fwhm2r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux3r, sky3r, junk5, junk6, el3r, pa3r, junk7, fwhm3r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux4r, sky4r, junk5, junk6, el4r, pa4r, junk7, fwhm4r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux5r, sky5r, junk5, junk6, el5r, pa5r, junk7, fwhm5r) == 11){
                        if( fscan( list5, junk2, junk3, junk4, flux6r, sky6r, junk5, junk6, el6r, pa6r, junk7, fwhm6r) == 11){
                           x_rot = xr_str - x_str
                           y_rot = yr_str - y_str
                           xr = x_str + x_rot
                           yr = y_str + y_rot
                           }}}}}}
                        }}}
                      }
	    }
            if(fwhm1 < maxfwhm){
                 x_org = x_org + x_str
                 y_org = y_org + y_str
                 xr_org = xr_org + x_rot
                 yr_org = yr_org + y_rot
	         print( junk1, " ", x_str, " ", y_str, " ", x_rot, " ", y_rot, >> tmpfile6 )
                 nselect = nselect + 1
                 ntotal = ntotal + 1
            }
            if( nrpoint == 1 ){
	    print( junk1, "   ", x_str, y_str, flux1, sky1, el1, pa1, fwhm1, flux2, sky2, el2, pa2, fwhm2, flux3, sky3, el3, pa3, fwhm3, \
                                               flux4, sky4, el4, pa4, fwhm4, flux5, sky5, el5, pa5, fwhm5, flux6, sky6, el6, pa6, fwhm6, \
                xr_str, yr_str, flux1r, sky1r, el1r, pa1r, fwhm1r, flux2r, sky2r, el2r, pa2r, fwhm2r, flux3r, sky3r, el3r, pa3r, fwhm3r, \
                                flux4r, sky4r, el4r, pa4r, fwhm4r, flux5r, sky5r, el5r, pa5r, fwhm5r, flux6r, sky6r, el6r, pa6r, fwhm6r, >> st_log1 )
            }
            else{
            print( junk1, "   ", x_str, y_str, flux1, sky1, el1, pa1, fwhm1, flux2, sky2, el2, pa2, fwhm2, flux3, sky3, el3, pa3, fwhm3, \
                                               flux4, sky4, el4, pa4, fwhm4, flux5, sky5, el5, pa5, fwhm5, flux6, sky6, el6, pa6, fwhm6, >> st_log1 )
            }}
            i = i+1
            if( i == nimage ){
                 if (nselect !=0 ){
                     x_org = int( x_org / nselect + 0.5)
                     y_org = int( y_org / nselect + 0.5)
                     print( x_org, y_org, nselect, >> tmpfile6_2 )
                     print( -x_org, -y_org, >> offset1 )
                 }
                 x_org = 0
                 y_org = 0
                 i = 0
                 nselect = 0
            }
         }

         xr_org = xr_org / ntotal
         yr_org = yr_org / ntotal

         tmpfile7 = mktemp( "tmp_file." )
         tmpfile8 = mktemp( "tmp_file." )
         tmpfile8_2 = mktemp( "tmp_file." )

         i=0
         j=0
         list6 = tmpfile6
         list6_2 = tmpfile6_2
         while( fscan( list6, junk1, x_str, y_str, x_rot, y_rot) == 5)
	 {
             if( i == 0 ){
                 if( fscan( list6_2, x_org, y_org, nselect ) == 3){}
             }
             tmpimage6 = mktemp( "tmp_im.")
             x_shift = x_org - x_str
             y_shift = y_org - y_str
             print( "imshift ", junk1, " ", tmpimage6, " ", x_shift, y_shift, "interp=linear boundar=constant" )
             imshift( junk1, tmpimage6, x_shift, y_shift, interp='linear', boundar='constant' )
             if( nrpoint == 1 ){
                 sina=( x_rot*yr_org - y_rot*xr_org ) / sqrt ( x_rot*x_rot + y_rot*y_rot ) / sqrt ( xr_org*xr_org + yr_org*yr_org )
                 ang=(sina+sina*sina*sina/6)/3.14159*180
                 print( "rotate ", tmpimage6, " ", tmpimage6, " ", ang, "xin=",x_org, "yin=",y_org, "xout=",x_org, "yout=",y_org, "boundar=constant" )
                 rotate( tmpimage6, tmpimage6, ang, xin=x_org, yin=y_org, xout=x_org, yout=y_org , boundar='constant' )
             }
             print( tmpimage6, >> tmpfile7 )
             i = i+1
             if( i == nselect )
                  {
                  tmpimage7 = mktemp( "tmp_im.")
                  print( tmpimage7, >> tmpfile8 )
                  imcomb("@"//tmpfile7 ,tmpimage7,combine='average',reject='sigclip',outtype='real',lthresh=INDEF,hthresh=INDEF,lsigma=2, hsigma=2)
                  imdelete ( "@"//tmpfile7 )
                  delete( tmpfile7,ver-,>&"dev$null" )
                  display(tmpimage7,1,fi+,zs+,zr+)
                  i = 0
                  j = j + 1
                  print( "Frame", j, " ended" )
                  if(j<10) print( output1,".00",j, >> tmpfile8_2 )
                  else if(j<100) print( output1,".0",j, >> tmpfile8_2 )
                  else print( output1,".",j, >> tmpfile8_2 )
                  }
	 }
         imrename( "@"//tmpfile8,"@"//tmpfile8_2 )
	 imcomb("@"//tmpfile8_2 ,output1,combine='median',reject='sigclip',outtype='real',lthresh=INDEF,hthresh=INDEF,lsigma=2, hsigma=2, weight='!NCOMBINE', offset=offset1)
         display(output1,1,fi+,zs+,zr+)

finish:
	delete( tmpfile3_2,ver-,>&"dev$null" )
	delete( tmpfile4,ver-,>&"dev$null" )
	delete( tmpfile5,ver-,>&"dev$null" )
	delete( tmpfile6,ver-,>&"dev$null" )
	delete( tmpfile6_2,ver-,>&"dev$null" )
	delete( tmpfile8,ver-,>&"dev$null" )
	print( 'This procedure ended.' )
	bye
end
